## coq 9.1.0%2Bdfsg

=== test-suite/Makefile ===
##########################################################################
##         #      The Rocq Prover / The Rocq Development Team           ##
##  v      #         Copyright INRIA, CNRS and contributors             ##
## <O___,, # (see version control and CREDITS file for authors & dates) ##
##   \VV/  ###############################################################
##    //   #    This file is distributed under the terms of the         ##
##         #     GNU Lesser General Public License Version 2.1          ##
##         #     (see LICENSE file for the text of the license)         ##
##########################################################################

# There is one %.v.log target per %.v test file. The target will be
# filled with the output, timings and status of the test. There is
# also one target per directory containing %.v files, that runs all
# the tests in it. As convenience, there is also the "bugs" target
# that runs all bug-related tests.

# The "summary" target outputs a summary of all tests that were run
# (but doesn't run them)

# The "run" target runs all tests that have not been run yet. To force
# all tests to be run, use the "clean" target.

.DEFAULT_GOAL:=all

###########################################################################
# Includes, see below for generation
###########################################################################

# Generate test-suite, when INSIDE_DUNE the file is guaranteed to
# exist, when called directly by make we need to look into the build
# directory.
DUNE_CONTEXT:=default
TEST_SUITE_CONFIG_FILE:=test_suite_config.inc

ifneq ($(MAKECMDGOALS),clean)
include $(TEST_SUITE_CONFIG_FILE)
endif

# Not inside Dune, build by hand
ifeq ($(INSIDE_DUNE),)
CONFIG_TO_MAKE_EXE:=../_build/$(DUNE_CONTEXT)/test-suite/tools/coq_config_to_make.exe
ROCQ_EXE:=../_build/install/$(DUNE_CONTEXT)/bin/rocq

$(TEST_SUITE_CONFIG_FILE):
	$(SHOW) 'coq_config_to_make > $@'
	$(HIDE)dune build $(CONFIG_TO_MAKE_EXE)
	$(HIDE)$(CONFIG_TO_MAKE_EXE) $(ROCQ_EXE) > $@
endif

#######################################################################
# Variables
#######################################################################

# COQPREFIX is quoted to anticipate the possibility of spaces in the directory name
# Note that this will later need an eval in shell to interpret the quotes
BIN:=$(COQPREFIX)/bin/

# An alternative is ifeq ($(OS),Windows_NT) using make's own variable.
ifeq ($(ARCH),win32)
  export FINDLIB_SEP=;

  # in output tests we call "rocq c output/foo.v"
  # this gets turned into (Filename.concat current_dir_name "output/foo.v")
  # (Coqcargs.add_compile)
  # for test stability across platforms we turn the \ from Filename.concat into a /
  CLEANUP_WINPATH=| sed 's:.\\$(<):./$(<):'
else
  export FINDLIB_SEP=:

  CLEANUP_WINPATH=
endif

# The $(shell echo) trick is necessary due to configure quoting
# filenames, still, this issue is tricky when paths contain spaces
export OCAMLPATH := $(shell echo $(COQPREFIX)/lib$(FINDLIB_SEP)$$OCAMLPATH)
export CAML_LD_LIBRARY_PATH:=$(shell echo $(COQPREFIX)/lib/stublibs):$(CAML_LD_LIBRARY_PATH)

# ROCQLIB is an env variable so no quotes
ROCQLIB?=

ifeq ($(ROCQLIB),)
# Guard againt the COQLIBINSTALL directory not existing, otherwise
# ocaml_pwd will error
ifneq ($(wildcard $(shell echo $(COQLIBINSTALL))),)
	ROCQLIB := $(shell ocaml ocaml_pwd.ml $(COQLIBINSTALL))
endif
endif
export ROCQLIB

ifeq ($(wildcard $(ROCQLIB)/theories/Init/Prelude.vo),)
  COQLIB_NOT_FOUND:=true
else
  COQLIB_NOT_FOUND:=false
endif

COQEXTRAFLAGS?=
COQFLAGS?=$(COQEXTRAFLAGS)

coqc := $(BIN)rocq c -q -R prerequisite TestSuite $(COQFLAGS)
coqchk := $(BIN)rocqchk -R prerequisite TestSuite
coqdoc := $(BIN)rocq doc
coqtop := $(BIN)rocq repl -q -test-mode -R prerequisite TestSuite

coqidetop := $(BIN)coqidetop

coqc_interactive := $(coqc) -test-mode
coqdep := $(BIN)rocq dep

# This is the convention for coq_makefile
OPT=-$(BEST)
export OPT

QUIET?=
VERBOSE?=

# if VERBOSE we print the command instead
# if QUIET we print nothing (except errors)
SHOW0 := $(if $(strip $(VERBOSE) $(QUIET)),true,echo)
SHOW := @$(SHOW0)
HIDE := $(if $(VERBOSE),,@)

# per test timing support (copied from CoqMakefile.in)
TIMED?=
TIMEFMT?="$(1) (real: %e, user: %U, sys: %S, mem: %M ko)"

ifneq (,$(TIMED))
ifeq (0,$(shell command time -f "" true >/dev/null 2>/dev/null; echo $$?))
STDTIME?=command time --quiet -f $(TIMEFMT) -o $(2)
else
ifeq (0,$(shell gtime --quiet -f "" true >/dev/null 2>/dev/null; echo $$?))
STDTIME?=gtime -f $(TIMEFMT) -o $(2)
else
STDTIME?=command time
endif
endif
else
STDTIME?=command time -f $(TIMEFMT) -o $(2)
endif

# args: 1=name of target, 2=command to time,
# 3=file to write time data to (optional, default $(1).time)
WITH_TIMER=$(if $(TIMED), $(call STDTIME,$(1),$(if $(3),$(3),$(1).time)) $(2), $(2))

REPORT_TIMER=$(if $(TIMED),$(foreach f,$(1),cat $(f).time 2>/dev/null || true;),:)

# read out an emacs config and look for coq-prog-args; if such exists, return it
get_coq_prog_args_helper = sed -n s'/^.*$(1):[[:space:]]*(\([^)]*\)).*/\1/p' $(2)
get_coq_prog_args = $(strip $(shell $(call get_coq_prog_args_helper,coq-prog-args,$(1))))
get_coqchk_prog_args = $(strip $(shell $(call get_coq_prog_args_helper,coqchk-prog-args,$(1))) $(filter "-impredicative-set",$(call get_coq_prog_args,$(1))))
SINGLE_QUOTE="
#" # double up on the quotes, in a comment, to appease the emacs syntax highlighter
# wrap the arguments in parens, but only if they exist
get_coq_prog_args_in_parens = $(subst $(SINGLE_QUOTE),,$(if $(call get_coq_prog_args,$(1)), ($(call get_coq_prog_args,$(1)))))
get_coqchk_prog_args_in_parens = $(subst $(SINGLE_QUOTE),,$(if $(call get_coqchk_prog_args,$(1)), ($(call get_coqchk_prog_args,$(1)))))

bogomips:=
ifneq (,$(wildcard /proc/cpuinfo))
  sedbogo := -e "s/bogomips.*: \([0-9]*\).*/\1/p" # i386, ppc
  sedbogo += -e "s/Cpu0Bogo.*: \([0-9]*\).*/\1/p" # sparc
  sedbogo += -e "s/BogoMIPS.*: \([0-9]*\).*/\1/p" # alpha
  bogomips := $(shell sed -n $(sedbogo) /proc/cpuinfo | head -1)
endif

ifeq (,$(bogomips))
  $(warning cannot run complexity tests (no bogomips found))
endif

# keep these synced with test-suite/save-logs.sh
log_success = "==========> SUCCESS <=========="
log_segfault = "==========> FAILURE <=========="
log_anomaly = "==========> FAILURE <=========="
log_failure = "==========> FAILURE <=========="
log_intro = "==========> TESTING $(1) <=========="

FAIL = >&2 echo 'FAILED    $@'
FAIL_CHK = >&2 echo 'FAILED    $(patsubst %.v.log,%.chk.log,$@)'

#######################################################################
# Testing subsystems
#######################################################################

# These targets can be skipped by doing `make TARGET=`
COMPLEXITY := $(if $(bogomips),complexity)
INTERACTIVE := interactive
UNIT_TESTS := unit-tests

# targets can be skipped by doing  `make DISABLED_SUBSYSTEMS="target1 target2"`
DISABLED_SUBSYSTEMS?=

VSUBSYSTEMS := prerequisite success failure bugs bugs-nocoqchk output output-coqtop \
  output-modulo-time $(INTERACTIVE) $(COMPLEXITY) modules stm \
  coqdoc ssr $(wildcard primitive/*) ltac2 coqchk

# All subsystems
SUBSYSTEMS := $(filter-out $(DISABLED_SUBSYSTEMS),$(VSUBSYSTEMS) misc ide ide coqchk output-coqchk coqwc coq-makefile precomputed-time-tests tools $(UNIT_TESTS))

# EJGA: This seems dangerous as first target...
.csdp.cache: .csdp.cache.test-suite
	$(SHOW) 'cp $< $@'
	$(HIDE)cp $< $@
	$(HIDE)chmod u+w $@

PREREQUISITELOG = $(addsuffix .log,$(wildcard prerequisite/*.v)) .csdp.cache

#######################################################################
# Phony targets
#######################################################################

.DELETE_ON_ERROR:
.PHONY: all run clean $(SUBSYSTEMS)

ifeq ($(COQLIB_NOT_FOUND),true)
all:
	@echo ""
	@echo "Coq's standard library has not been built; please run: "
	@echo "  - make world"
	@echo "(looked in $(COQLIBINSTALL))"
ifeq ($(COQLIBINSTALL),)
	@echo "config file $(TEST_SUITE_CONFIG_FILE) seems corrupt:"
	@cat $(TEST_SUITE_CONFIG_FILE)
endif
	@false
else
ifeq ($(TIMED),)
all: run
	$(MAKE) report
else
all:
	$(MAKE) run | tee time-of-build.log
	python ../tools/make-one-time-file.py --real time-of-build.log
	$(MAKE) report
endif
endif

# do nothing
.PHONY: noop
noop: ;

run: $(SUBSYSTEMS)

clean:
	rm -f trace .csdp.cache .nia.cache .lia.cache
	rm -f misc/universes/all_stdlib.v
	$(SHOW) 'RM        <**/*.stamp> <**/*.vo> <**/*.log> <**/*.glob> <**/*.aux> <**/*.time>'
	$(HIDE)find . \( \
	  -name '*.stamp' -o -name '*.vo' -o -name '*.vos' -o -name '*.vok' -o -name '*.log' -o -name '*.glob' -o -name '*.aux' -o -name '*.time' \
	  \) -exec rm -f {} +
	$(SHOW) 'RM        <**/*.cmx> <**/*.cmi> <**/*.o> <**/*.test>'
	$(HIDE)find unit-tests \( \
	  -name '*.cmx' -o -name '*.cmi' -o -name '*.o' -o -name '*.test' \
	  \) -exec rm -f {} +

#######################################################################
# Per-subsystem targets
#######################################################################

define vdeps
$(1): $(patsubst %.v,%.v.log,$(wildcard $(1)/*.v))
endef
$(foreach S,$(VSUBSYSTEMS),$(eval $(call vdeps,$(S))))

#######################################################################
# Summary
#######################################################################

# using "-L 999" because some versions of tail do not accept more than ~1k arguments
summary_dir = echo $(1); find $(2) -name '*.log' -print0 | xargs -0 -L 999  tail -q -n1 | sort

.PHONY: summary summary.log

summary:
	@{ \
	  $(call summary_dir, "Preparing tests", prerequisite); \
	  $(call summary_dir, "Success tests", success); \
	  $(call summary_dir, "Failure tests", failure); \
	  $(call summary_dir, "Bugs tests", bugs); \
	  $(call summary_dir, "Bugs tests (no coqchk)", bugs-nocoqchk); \
	  $(call summary_dir, "Output tests", output); \
	  $(call summary_dir, "Output tests with coqtop", output-coqtop); \
	  $(call summary_dir, "Output (modulo time changes) tests", output-modulo-time); \
	  $(call summary_dir, "Interactive tests", interactive); \
	  $(call summary_dir, "Miscellaneous tests", misc); \
	  $(call summary_dir, "Complexity tests", complexity); \
	  $(call summary_dir, "Module tests", modules); \
	  $(call summary_dir, "Primitive tests", primitive); \
	  $(call summary_dir, "STM tests", stm); \
	  $(call summary_dir, "SSR tests", ssr); \
	  $(call summary_dir, "IDE tests", ide); \
	  $(call summary_dir, "Coqchk tests", coqchk); \
	  $(call summary_dir, "Output tests with coqchk", output-coqchk); \
	  $(call summary_dir, "Coqwc tests", coqwc); \
	  $(call summary_dir, "Coq makefile", coq-makefile); \
	  $(call summary_dir, "Precomputed time tests", precomputed-time-tests); \
	  $(call summary_dir, "Coqdoc tests", coqdoc); \
	  $(call summary_dir, "tools/ tests", tools); \
	  $(call summary_dir, "Unit tests", unit-tests); \
	  $(call summary_dir, "Ltac2 tests", ltac2); \
	  nb_success=`grep -e $(log_success) -r . -l --include="*.log" --exclude-dir=logs | wc -l`; \
	  nb_failure=`grep -e $(log_failure) -r . -l --include="*.log" --exclude-dir=logs | wc -l`; \
	  nb_tests=`expr $$nb_success + $$nb_failure`; \
	  percentage=`expr 100 \* $$nb_success / $$nb_tests`; \
	  echo; \
	  echo "$$nb_success tests passed over $$nb_tests, i.e. $$percentage %"; \
	}

summary.log:
	$(SHOW) BUILDING SUMMARY FILE
	$(HIDE)$(MAKE) --quiet summary > "$@"

report: summary.log
	$(HIDE)bash report.sh

#######################################################################
# Unit tests
#######################################################################

# COQLIBINSTALL is quoted in config/make thus we must unquote it,
# otherwise the directory name will include the quotes, see
# see for example https://stackoverflow.com/questions/10424645/how-to-convert-a-quoted-string-to-a-normal-one-in-makefile

OCAMLOPT := $(OCAMLFIND) opt $(CAMLFLAGS)
OCAMLC := $(OCAMLFIND) ocamlc $(CAMLFLAGS)

# ML files from unit-test framework, not containing tests

## coq 9.1.0+dfsg

=== Makefile ===
##########################################################################
##         #      The Rocq Prover / The Rocq Development Team           ##
##  v      #         Copyright INRIA, CNRS and contributors             ##
## <O___,, # (see version control and CREDITS file for authors & dates) ##
##   \VV/  ###############################################################
##    //   #    This file is distributed under the terms of the         ##
##         #     GNU Lesser General Public License Version 2.1          ##
##         #     (see LICENSE file for the text of the license)         ##
##########################################################################

# Dune Makefile for Rocq

.PHONY: help help-install states world rocqide watch check    # Main developer targets
.PHONY: refman-html refman-pdf corelib-html apidoc     # Documentation targets
.PHONY: test-suite dev-targets
.PHONY: fmt ocheck obuild ireport clean               # Maintenance targets
.PHONY: dunestrap release install                 # Miscellaneous

# We don't allow parallel build here, this is just a placehoder for
# dune commands for the most part
.NOTPARALLEL:

###########################################################################
# The SHOW and HIDE variables control whether make will echo complete commands
# or only abbreviated versions.
# Quiet mode is ON by default except if VERBOSE=1 option is given to make
# Used only by targets which don't go through dune (eg doc_gram_rsts)

VERBOSE ?=
SHOW := $(if $(VERBOSE),@true "",@echo "")
HIDE := $(if $(VERBOSE),,@)

# use DUNEOPT=--display=short for a more verbose build
# DUNEOPT=--display=short

help:
	@echo ""
	@echo "Welcome to Rocq's Dune-based build system. If you are final user type"
	@echo "make help-install for installation instructions. Common developer targets are:"
	@echo ""
	@echo "  - states: build a minimal functional rocq repl"
	@echo "  - world:  build main public binaries and libraries in developer mode (no rocqide)"
	@echo "  - watch:  build main public binaries and libraries [continuous build]"
	@echo "  - rocqide: build rocqide binary in developer mode"
	@echo "  - check:  build all ML files as fast as possible"
	@echo "  - test-suite: run Rocq's test suite [env NJOBS=N to set job parallelism]"
	@echo "  - dunestrap: Generate the dune rules for vo files"
	@echo ""
	@echo "  Note: running ./configure is not recommended for developers,"
	@echo "        see dev/doc/build-system.dune.md for more info"
	@echo "  Note: these targets produce a developer build, not suitable"
	@echo "        for distribution to end-users or install"
	@echo ""
	@echo " To run an \$$app \\in {coqc,coqtop,coqtop.byte,rocqide}:"
	@echo ""
	@echo "  - use 'dune exec -- dev/shim/\$$app args'"
	@echo "    Example: 'dune exec -- dev/shim/coqc file.v'"
	@echo ""
	@echo " Documentation targets:"
	@echo ""
	@echo "  - refman-html: build Rocq's reference manual [HTML version]"
	@echo "  - refman-pdf:  build Rocq's reference manual [PDF version]"
	@echo "  - corelib-html: build Rocq's Corelib documentation [HTML version]"
	@echo "  - apidoc:      build ML API documentation"
	@echo ""
	@echo " Miscellaneous targets:"
	@echo ""
	@echo "  - fmt:     run ocamlformat on the codebase"
	@echo "  - ocheck:  check for a selection of supported OCaml versions [requires OPAM]"
	@echo "  - obuild:  build for a selection of supported OCaml versions [requires OPAM]"
	@echo "  - ireport: build with optimized flambda settings and emit an inline report"
	@echo "  - clean:   remove build directory and autogenerated files"
	@echo "  - help:    show this message"
	@echo ""
	@echo " Type 'make help-install' for installation instructions"
	@echo " Type 'make dev-targets' for more developer targets"

dev-targets:
	@echo ""
	@echo "In order to get a functional Rocq install layout, the world target is required."
	@echo "However, This is often inconvenient for developers, due to the large amount of"
	@echo "files that world will build. We provide some useful subtargets here:"
	@echo ""
	@echo "  - theories-foo: for each directory theories/Corelib/Foo, build the vo files for it and set them up in _build/install/default."
	@echo "    For instance the init target builds the prelude, combined with rocq-runtime.install it produces a fully functional layout in _build/install/default."

help-install:
	@echo ""
	@echo "The Dune-based Rocq build is split into several packages; see Dune and dev/doc"
	@echo "documentation for more details. A quick install of Rocq alone can be done with"
	@echo ""
	@echo " $$ make dunestrap"
	@echo " $$ dune build -p rocq-runtime,coq-core,rocq-core"
	@echo " $$ dune install --prefix=<install_prefix> rocq-runtime coq-core rocq-core"
	@echo ""
	@echo " Provided opam/dune packages are:"
	@echo ""
	@echo "  - rocq-runtime: base Rocq package, toplevel compilers, plugins, tools, no corelib, no stdlib, no GTK"
	@echo "  - coq-core: compat binaries (coqc instead of rocq compile, etc)"
	@echo "  - rocq-core: Rocq's prelude and corelib"
	@echo "  - coqide-server: XML protocol language server"
	@echo "  - rocqide: RocqIDE gtk application"
	@echo "  - rocq: meta package depending on rocq-runtime rocq-core rocq-stdlib"
	@echo "    (also calls the test suite when using --with-test)"
	@echo "  - coq: meta package depending on rocq coq-core coq-stdlib"
	@echo "    (also calls the test suite when using --with-test)"
	@echo ""
	@echo " To build a package, you can use:"
	@echo ""
	@echo "  - 'dune build package.install' : build package in developer mode"
	@echo "  - 'dune build -p package' : build package in release mode"
	@echo ""
	@echo " Packages _must_ be installed only if built using release mode, to install a package use: "
	@echo ""
	@echo "  - 'dune install --prefix=<install_prefix> package'"
	@echo ""
	@echo " Note that '--prefix' must be passed to dune install. The '-prefix' passed to"
	@echo " configure tells Rocq where to look for libraries."
	@echo ""
	@echo " Note that building a package in release mode ignores other packages present in"
	@echo " the worktree. See Dune documentation for more information."

# We setup the root even in dev mode, to avoid some problems.  We used
# this in the past to workaround a bug in opam, but the bug was that
# we didn't pass `-p` to the dune build below.
#
# This would be fixed once dune can directly use `(include
# theories_dune)` in our files.
DUNESTRAPOPT=--root .

# We regenerate always as to correctly track deps, can do better
# We do a single call to dune as to avoid races and locking
ifneq ($(COQ_SPLIT),) # avoid depending on local rocq-runtime
_build/default/corelib_dune_split _build/default/ltac2_dune_split .dune-stamp: FORCE
	dune build $(DUNEOPT) $(DUNESTRAPOPT) corelib_dune_split ltac2_dune_split
	touch .dune-stamp

theories/Corelib/dune: .dune-stamp
	cp -a _build/default/corelib_dune_split $@ && chmod +w $@

theories/Ltac2/dune: .dune-stamp
	cp -a _build/default/ltac2_dune_split $@ && chmod +w $@
else
_build/default/corelib_dune _build/default/ltac2_dune .dune-stamp: FORCE
	dune build $(DUNEOPT) $(DUNESTRAPOPT) corelib_dune ltac2_dune
	touch .dune-stamp

theories/Corelib/dune: .dune-stamp
	cp -a _build/default/corelib_dune $@ && chmod +w $@

theories/Ltac2/dune: .dune-stamp
	cp -a _build/default/ltac2_dune $@ && chmod +w $@
endif

FORCE: ;

DUNE_FILES=theories/Corelib/dune theories/Ltac2/dune

dunestrap: $(DUNE_FILES)

states: dunestrap
	dune build $(DUNEOPT) dev/shim/coqtop

MAIN_TARGETS:=rocq-runtime.install coq-core.install rocq-core.install \
  coqide-server.install rocq-devtools.install

world: dunestrap
	dune build $(DUNEOPT) $(MAIN_TARGETS)

rocqide:
	dune build $(DUNEOPT) rocqide.install

watch:
	dune build $(DUNEOPT) $(MAIN_TARGETS) -w

check:
	dune build $(DUNEOPT) @check

test-suite: dunestrap
	dune runtest --no-buffer $(DUNEOPT)

refman-html: dunestrap
	dune build --no-buffer @refman-html

refman-pdf: dunestrap
	dune build --no-buffer @refman-pdf

corelib-html: dunestrap
	dune build @corelib-html

apidoc:
	dune build $(DUNEOPT) @doc

# We define this target as to override Make's built-in one
install:
	@echo "To install Rocq using dune, use 'dune build -p P && dune install P'"
	@echo "where P is any of the packages defined by opam files in the root dir"
	@false

fmt:
	dune build @fmt --auto-promote

ocheck:
	dune build $(DUNEOPT) @check --workspace=dev/dune-workspace.all

obuild: dunestrap
	dune build $(DUNEOPT) @default --workspace=dev/dune-workspace.all

ireport:
	dune clean
	dune build $(DUNEOPT) @install --profile=ireport

clean:
	rm -f .dune-stamp theories/Corelib/dune theories/Ltac2/dune
	dune clean

# docgram

DOC_GRAM:=_build/default/doc/tools/docgram/doc_grammar.exe

# not worth figuring out dependencies, just leave it to dune
.PHONY: $(DOC_GRAM)
$(DOC_GRAM):
	dune build $(DUNEOPT) $@

include doc/Makefile.docgram

# This requires a install layout to be available.

CONTEXT=_build/install/default

# XXX: Port this to a dune alias so the build is hygienic!
.PHONY: plugin-tutorial
plugin-tutorial: world
	$(MAKE) OCAMLPATH=$(shell pwd)/$(CONTEXT)/lib/ COQBIN="$(shell pwd)/$(CONTEXT)/bin/" -C doc/plugin_tutorial

# This is broken in a very weird way with a permission error... see
# the rule in doc/plugin_tutorial/dune:

# plugin-tutorial: dunestrap
#	dune build @plugin-tutorial

# ci-* targets

CI_PURE_DUNE:=1
export CI_PURE_DUNE
include Makefile.ci

# Custom targets to create subsets of the world target but with less
# compiled files. This is desired when we want to have our Rocq Dune
# build with Rocq developments that are not dunerized and thus still
# expect an install layout with a working Rocq setup, but smaller than
# world.
#
# Unfortunately, Dune still lacks the capability to refer to install
# targets in rules, see https://github.com/ocaml/dune/issues/3192 ;
# thus we can't simply yet use `%{pkg:coq:theories/Corelib/Arith/Arith.vo` to
# have the rule install the target, we thus imitate such behavior
# using make as a helper.

# $(1) is the directory (theories/Corelib/Foo/)
# $(2) is the name (foo)
define subtarget =
  .PHONY: theories-$(2)

  $(2)_FILES=$$(wildcard $(1)*.v)
  $(2)_FILES_PATH=$$(addprefix _build/install/default/lib/coq/, $$($(2)_FILES:.v=.vo))

  theories-$(2):
	@echo "DUNE $(1)*.vo"
	@dune build $$($(2)_FILES_PATH)
endef

$(foreach subdir,$(wildcard theories/Corelib/*/),$(eval $(call subtarget,$(subdir),$(shell echo $(subst /,,$(subst theories/Corelib/,,$(subdir))) | tr A-Z a-z))))

# Other common dev targets:
#
# dune build rocq-runtime.install
# dune build coq.install
# dune build rocqide.install
#
# Packaging / OPAM targets:
#
# dune -p coq @install
# dune -p rocqide @install

=== doc/tools/coqrst/notations/Makefile ===
##########################################################################
##         #      The Rocq Prover / The Rocq Development Team           ##
##  v      #         Copyright INRIA, CNRS and contributors             ##
## <O___,, # (see version control and CREDITS file for authors & dates) ##
##   \VV/  ###############################################################
##    //   #    This file is distributed under the terms of the         ##
##         #     GNU Lesser General Public License Version 2.1          ##
##         #     (see LICENSE file for the text of the license)         ##
##########################################################################
# Parsing compact tactic notation syntax in

TEST_INPUT="unfold {+, @qualid|@string at {+, num}}"

python:
	antlr4 -Dlanguage=Python3 -visitor -no-listener TacticNotations.g

java:
	antlr4 -Dlanguage=Java TacticNotations.g && javac TacticNotations*.java

test: java
	grun TacticNotations top -tree <<< "$(TEST_INPUT)"

gui: java
	grun TacticNotations top -gui <<< "$(TEST_INPUT)"

sample:
	cd ..; python3 -m coqnotations.driver < ../tests/tactics > ../tests/antlr-notations.html

=== test-suite/coq-makefile/findlib-package/findlib/foo/Makefile ===
-include ../../Makefile.conf

CO="$(COQMF_OCAMLFIND)" opt
CB="$(COQMF_OCAMLFIND)" ocamlc

all:
	$(CO) -c foolib.ml -thread
	$(CO) -linkall -a foolib.cmx -o foo.cmxa
	$(CO) -shared -linkall foo.cmxa -o foo.cmxs
	$(CB) -c foolib.ml -thread
	$(CB) -linkall -a foolib.cmo -o foo.cma
	$(CB) -c foo.mli -thread # empty .mli file, to be understood

clean:
	rm -f *.cmo *.cma *.cmx *.cmxa *.cmi *.o *.a

=== debian/changelog ===
coq (9.1.0+dfsg-2) experimental; urgency=medium

  * Update depends from why to why3 (Closes: #1117585).

 -- Julien Puydt <jpuydt@debian.org>  Wed, 29 Oct 2025 00:18:57 +0100

coq (9.1.0+dfsg-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 17 Sep 2025 06:58:08 +0200

coq (9.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 22 Aug 2025 11:39:19 +0200

=== debian/control ===
Source: coq
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Benjamin Barenblat <bbaren@debian.org>,
 Julien Puydt <jpuydt@debian.org>,
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 dh-coq,
 dh-ocaml,
 dh-python,
 ocaml-dune,
 ocaml,
 ocaml-findlib (>= 1.8.0),
 libfindlib-ocaml-dev,
 liblablgtk3-ocaml-dev,
 liblablgtksourceview3-ocaml-dev (>= 3.0~beta8),
 libnum-ocaml-dev,
 libounit-ocaml-dev,
 libzarith-ocaml-dev,
 python3,
 rsync,
 tex-common
Rules-Requires-Root: no
Homepage: http://coq.inria.fr/
Vcs-Browser: https://salsa.debian.org/ocaml-team/coq
Vcs-Git: https://salsa.debian.org/ocaml-team/coq.git

Package: coq
Architecture: any
Depends:
 libcoq-core (= ${binary:Version}),
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 ocaml,
 ocaml-findlib,
 python3
Provides: coq-${F:CoqABI}
Suggests:
 rocqide | proofgeneral,
 ledit | readline-editor,
 libcoq-core-ocaml-dev,
 why3,
 coq-doc
Description: proof assistant for higher-order logic (toplevel and compiler)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides coqtop, a command line interface to Coq.
 .
 A graphical interface for Coq is provided in the coqide package.
 Coq can also be used with ProofGeneral, which allows proofs to be
 edited using emacs and xemacs. This requires the proofgeneral
 package to be installed.

Package: rocqide
Architecture: any
Depends:
 coq (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Replaces: coqide
Conflicts: coqide
Description: proof assistant for higher-order logic (gtk interface)
 Rocq is a theorem prover for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides RocqIde, a graphical user interface for
 developing proofs.

Package: libcoq-core
Architecture: any
Depends: ${misc:Depends}
Recommends: coq
Provides: ${coq:Provides}
Description: proof assistant for higher-order logic (theories)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides existing theories that new proofs can be
 based upon, including theories of arithmetic and Boolean values.

Package: libcoq-core-ocaml
Section: ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Description: runtime libraries for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides runtime libraries for Coq.

Package: libcoq-core-ocaml-dev
Section: ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: development libraries and tools for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides and libraries needed to develop OCaml-side
 extensions to Coq.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_OPTIONS += noautodbgsym

include /usr/share/ocaml/ocamlvars.mk

COQ_VERSION := 9.1.0
COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)

PACKAGES := $(shell dh_listpackages)

export OCAMLINIT_SED += \
  -e 's%@CoqVersion@%$(COQ_VERSION)%' \
  -e 's%@CoqABI@%$(COQ_ABI)%'

%:
	+dh $@ --with coq,ocaml,python3

override_dh_auto_configure:
	./configure -prefix=/usr -libdir=$(OCAML_STDLIB_DIR)/coq -mandir=/usr/share/man

override_dh_auto_build:
	make dunestrap
	dune build -p rocq-runtime,coq-core,rocq-core,coqide-server,rocqide --display=verbose

# Check that $(COQ_VERSION) has the right value
	ACTUAL_COQ_VERSION="$$(./_build/install/default/bin/rocq --version | awk '/version/{print $$5}')"; \
	if [ "$$ACTUAL_COQ_VERSION" != "$(COQ_VERSION)" ]; then \
	  echo "Please set COQ_VERSION to $$ACTUAL_COQ_VERSION in debian/rules"; \
	  exit 2; \
	fi

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# OCAMLPATH=$(CURDIR)/_build_vo/default/lib make -C test-suite COQBIN=$(CURDIR)/_build_vo/default/bin/ COQLIB=$(CURDIR)/_build_vo/default/lib/coq
	@echo "TESTS ARE DISABLED FOR NOW!"
endif

override_dh_auto_install:
	# raw installation
	dune install rocq-runtime coq-core rocq-core coqide-server rocqide \
		--destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) --mandir=/usr/share/man
	# cleaning what upstream installs and we don't (need to) ship
	find $(CURDIR)/debian/tmp -name LICENSE -delete
	find $(CURDIR)/debian/tmp -name README.md -delete
	find $(CURDIR)/debian/tmp -name "*.byte*" -delete
	find $(CURDIR)/debian/tmp -name "*.opt*" -delete
	rm -rf  $(CURDIR)/debian/tmp/usr/doc/rocqide/odoc-pages \
		$(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/rocq-runtime/revision \
		$(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/coqide-server
	find $(CURDIR)/debian/tmp -empty -delete
	# ok, now we detect what to ship
	find debian/tmp$(OCAML_STDLIB_DIR)/rocq-runtime -regextype posix-awk \
	  -regex '.*\.(cma|cmxs)$$' \
	  >> debian/libcoq-core-ocaml.install
	find debian/tmp$(OCAML_STDLIB_DIR)/rocq-runtime -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
	  >> debian/libcoq-core-ocaml-dev.install

override_dh_gencontrol:
	for u in $(PACKAGES); do \
	  echo 'F:OCamlABI=$(OCAML_ABI)' >> debian/$$u.substvars; \
	  echo 'F:CoqABI=$(COQ_ABI)' >> debian/$$u.substvars; \
	done
	dh_gencontrol

# why is this necessary?
override_dh_fixperms:
	dh_fixperms
	find $(CURDIR)/debian -name TimeFileMaker.py -exec chmod -x '{}' \;

override_dh_auto_clean:
	make clean
	rm -f config/Makefile config/coq_config.ml config/coq_config.py config/dune.c_flags
	rm -f theories/dune user-contrib/Ltac2/dune

=== debian/watch ===
version=4
opts="\
dversionmangle=s/\+dfsg.*$//,\
filenamemangle=s/.+\/[vV]?(\d\S+)\.tar\.gz/coq-$1\.tar\.gz/,\
repack,repacksuffix=+dfsg,\
" \
https://github.com/coq/coq/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz
